
_Write_DAC:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 8
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;main.c,21 :: 		void Write_DAC( unsigned int vout)
;main.c,24 :: 		short int i=0;
;main.c,25 :: 		dato[0] =   Dir_DAC;
	MOVW       R30, R28
	LDI        R27, 192
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;main.c,26 :: 		dato[1] =   Esc_DAC;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 64
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;main.c,27 :: 		dato[2] = (vout / 16);       // Upper data bits     (D11.D10.D9.D8.D7.D6.D5.D4)
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 4
	MOVW       R16, R2
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	ST         Z+, R16
	ST         Z+, R17
;main.c,28 :: 		dato[3] = (vout % 16) << 4;  // Lower data bits     (D3.D2.D1.D0.x.x.x.x)
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 6
	MOVW       R16, R2
	ANDI       R16, 15
	ANDI       R17, 0
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	ST         Z+, R16
	ST         Z+, R17
;main.c,29 :: 		soft_i2c_Start();
	CALL       _Soft_I2C_Start+0
;main.c,30 :: 		for(i=0; i<=3; i++) {
; i start address is: 20 (R20)
	LDI        R20, 0
; i end address is: 20 (R20)
L_Write_DAC0:
; i start address is: 20 (R20)
	LDI        R16, 3
	CP         R16, R20
	BRGE       L__Write_DAC72
	JMP        L_Write_DAC1
L__Write_DAC72:
;main.c,31 :: 		soft_i2c_Write(dato[i]);
	MOVW       R18, R28
	MOV        R16, R20
	LDI        R17, 0
	SBRC       R20, 7
	LDI        R17, 255
	LSL        R16
	ROL        R17
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _Soft_I2C_Write+0
	POP        R2
	POP        R3
;main.c,30 :: 		for(i=0; i<=3; i++) {
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
;main.c,32 :: 		}
; i end address is: 20 (R20)
	JMP        L_Write_DAC0
L_Write_DAC1:
;main.c,33 :: 		Soft_I2C_Stop();
	CALL       _Soft_I2C_Stop+0
;main.c,34 :: 		}
L_end_Write_DAC:
	ADIW       R28, 7
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Write_DAC

_Write_volt:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 4
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;main.c,36 :: 		void Write_volt( unsigned int vout)
;main.c,40 :: 		PORTB2_bit=1;
	IN         R27, PORTB2_bit+0
	SBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;main.c,42 :: 		VSAL= (vout/0.4884);
	MOVW       R16, R2
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	LDI        R20, 145
	LDI        R21, 15
	LDI        R22, 250
	LDI        R23, 62
	CALL       _float_fpdiv1+0
;main.c,43 :: 		VSAL=(unsigned int)VSAL;
	CALL       _float_fpint+0
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	STD        Y+0, R16
	STD        Y+1, R17
	STD        Y+2, R18
	STD        Y+3, R19
;main.c,45 :: 		for(i=i; i<=VSAL; i++){  //
L_Write_volt3:
	LDS        R16, _i+0
	LDS        R17, _i+1
	LDS        R18, _i+2
	LDS        R19, _i+3
	CALL       _float_slong2fp+0
	PUSH       R3
	PUSH       R2
	LDD        R20, Y+0
	LDD        R21, Y+1
	LDD        R22, Y+2
	LDD        R23, Y+3
	CALL       _float_op_lequ+0
	OR         R0, R0
	LDI        R27, 0
	BREQ       L__Write_volt74
	LDI        R27, 1
L__Write_volt74:
	MOV        R16, R27
	POP        R2
	POP        R3
	TST        R16
	BRNE       L__Write_volt75
	JMP        L_Write_volt4
L__Write_volt75:
;main.c,46 :: 		Write_DAC(i);                 // Send value to DAC chip
	PUSH       R3
	PUSH       R2
	LDS        R2, _i+0
	LDS        R3, _i+1
	CALL       _Write_DAC+0
	POP        R2
	POP        R3
;main.c,47 :: 		Delay_ms(10);                         // Slow down key repeat pace
	LDI        R17, 208
	LDI        R16, 202
L_Write_volt6:
	DEC        R16
	BRNE       L_Write_volt6
	DEC        R17
	BRNE       L_Write_volt6
	NOP
;main.c,45 :: 		for(i=i; i<=VSAL; i++){  //
	LDS        R16, _i+0
	LDS        R17, _i+1
	LDS        R18, _i+2
	LDS        R19, _i+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _i+0, R16
	STS        _i+1, R17
	STS        _i+2, R18
	STS        _i+3, R19
;main.c,48 :: 		}
	JMP        L_Write_volt3
L_Write_volt4:
;main.c,49 :: 		for(i=i; i>=VSAL; i--){  //
L_Write_volt8:
	LDS        R16, _i+0
	LDS        R17, _i+1
	LDS        R18, _i+2
	LDS        R19, _i+3
	CALL       _float_slong2fp+0
	PUSH       R3
	PUSH       R2
	LDD        R20, Y+0
	LDD        R21, Y+1
	LDD        R22, Y+2
	LDD        R23, Y+3
	CALL       _float_op_gequ+0
	OR         R0, R0
	LDI        R27, 0
	BREQ       L__Write_volt76
	LDI        R27, 1
L__Write_volt76:
	MOV        R16, R27
	POP        R2
	POP        R3
	TST        R16
	BRNE       L__Write_volt77
	JMP        L_Write_volt9
L__Write_volt77:
;main.c,50 :: 		Write_DAC(i);                 // Send value to DAC chip
	PUSH       R3
	PUSH       R2
	LDS        R2, _i+0
	LDS        R3, _i+1
	CALL       _Write_DAC+0
	POP        R2
	POP        R3
;main.c,51 :: 		Delay_ms(10);                         // Slow down key repeat pace
	LDI        R17, 208
	LDI        R16, 202
L_Write_volt11:
	DEC        R16
	BRNE       L_Write_volt11
	DEC        R17
	BRNE       L_Write_volt11
	NOP
;main.c,49 :: 		for(i=i; i>=VSAL; i--){  //
	LDS        R16, _i+0
	LDS        R17, _i+1
	LDS        R18, _i+2
	LDS        R19, _i+3
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	STS        _i+0, R16
	STS        _i+1, R17
	STS        _i+2, R18
	STS        _i+3, R19
;main.c,52 :: 		}
	JMP        L_Write_volt8
L_Write_volt9:
;main.c,53 :: 		PORTB2_bit=0;
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;main.c,54 :: 		}
L_end_Write_volt:
	ADIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Write_volt

_Voltmeter:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;main.c,55 :: 		void Voltmeter(){
;main.c,58 :: 		unsigned int adc_rd=0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
;main.c,59 :: 		short int  j=0;
;main.c,60 :: 		char aux=0;
	LDI        R27, 0
	STD        Y+0, R27
;main.c,62 :: 		for(j=0; j<=2; j++){
	LDI        R27, 0
	STD        Y+1, R27
L_Voltmeter13:
	LDD        R17, Y+1
	LDI        R16, 2
	CP         R16, R17
	BRGE       L__Voltmeter79
	JMP        L_Voltmeter14
L__Voltmeter79:
;main.c,63 :: 		aux=0;
	LDI        R27, 0
	STD        Y+0, R27
;main.c,64 :: 		adc_rd= ADC_measuring(2);
	LDI        R27, 2
	MOV        R2, R27
	CALL       _ADC_measuring+0
;main.c,65 :: 		vdd = (long)adc_rd * 2000; //get the voltage values.
	LDI        R18, 0
	MOV        R19, R18
	LDI        R20, 208
	LDI        R21, 7
	LDI        R22, 0
	LDI        R23, 0
	CALL       _HWMul_32x32+0
;main.c,66 :: 		vdd = vdd / 1023;
	LDI        R20, 255
	LDI        R21, 3
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
;main.c,67 :: 		TM1637_DisplayDecimal(vdd,0);
	CLR        R4
	CLR        R5
	MOVW       R2, R16
	CALL       _TM1637_DisplayDecimal+0
;main.c,68 :: 		delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L_Voltmeter16:
	DEC        R16
	BRNE       L_Voltmeter16
	DEC        R17
	BRNE       L_Voltmeter16
	DEC        R18
	BRNE       L_Voltmeter16
	NOP
;main.c,69 :: 		if (Button(&PIND,0,10,1))  TM1637_DisplayDecimal(volt,0), aux==1;
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	CLR        R4
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__Voltmeter80
	JMP        L_Voltmeter18
L__Voltmeter80:
	CLR        R4
	CLR        R5
	LDS        R2, _volt+0
	LDS        R3, _volt+1
	CALL       _TM1637_DisplayDecimal+0
L_Voltmeter18:
;main.c,62 :: 		for(j=0; j<=2; j++){
	LDD        R16, Y+1
	SUBI       R16, 255
	STD        Y+1, R16
;main.c,70 :: 		}
	JMP        L_Voltmeter13
L_Voltmeter14:
;main.c,71 :: 		if(aux==1)j=2;
	LDD        R16, Y+0
	CPI        R16, 1
	BREQ       L__Voltmeter81
	JMP        L_Voltmeter19
L__Voltmeter81:
	JMP        L_Voltmeter20
L_Voltmeter19:
;main.c,72 :: 		else j=1;
L_Voltmeter20:
;main.c,73 :: 		}
L_end_Voltmeter:
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Voltmeter

_set_up:

;main.c,74 :: 		void set_up() {
;main.c,75 :: 		DDC2_bit=0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	IN         R27, DDC2_bit+0
	CBR        R27, BitMask(DDC2_bit+0)
	OUT        DDC2_bit+0, R27
;main.c,76 :: 		DDD0_bit=0;
	IN         R27, DDD0_bit+0
	CBR        R27, BitMask(DDD0_bit+0)
	OUT        DDD0_bit+0, R27
;main.c,77 :: 		DDD4_bit=0;
	IN         R27, DDD4_bit+0
	CBR        R27, BitMask(DDD4_bit+0)
	OUT        DDD4_bit+0, R27
;main.c,78 :: 		DDD5_bit=0;
	IN         R27, DDD5_bit+0
	CBR        R27, BitMask(DDD5_bit+0)
	OUT        DDD5_bit+0, R27
;main.c,79 :: 		DDD6_bit=0;
	IN         R27, DDD6_bit+0
	CBR        R27, BitMask(DDD6_bit+0)
	OUT        DDD6_bit+0, R27
;main.c,80 :: 		DDD7_bit=0;
	IN         R27, DDD7_bit+0
	CBR        R27, BitMask(DDD7_bit+0)
	OUT        DDD7_bit+0, R27
;main.c,81 :: 		DDD1_bit=1;    //LED_scale
	IN         R27, DDD1_bit+0
	SBR        R27, BitMask(DDD1_bit+0)
	OUT        DDD1_bit+0, R27
;main.c,82 :: 		DDB0_bit=1;   //DATA
	IN         R27, DDB0_bit+0
	SBR        R27, BitMask(DDB0_bit+0)
	OUT        DDB0_bit+0, R27
;main.c,83 :: 		DDB1_bit=1;   //CLK
	IN         R27, DDB1_bit+0
	SBR        R27, BitMask(DDB1_bit+0)
	OUT        DDB1_bit+0, R27
;main.c,84 :: 		DDB2_bit=1;   //LED_waiting
	IN         R27, DDB2_bit+0
	SBR        R27, BitMask(DDB2_bit+0)
	OUT        DDB2_bit+0, R27
;main.c,85 :: 		PORTD1_bit=0;
	IN         R27, PORTD1_bit+0
	CBR        R27, BitMask(PORTD1_bit+0)
	OUT        PORTD1_bit+0, R27
;main.c,86 :: 		PORTB0_bit=0;
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;main.c,87 :: 		PORTB1_bit=0;
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;main.c,88 :: 		PORTB2_bit=0;
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;main.c,89 :: 		Soft_I2C_Init();
	CALL       _Soft_I2C_Init+0
;main.c,90 :: 		TM1637_Init();
	CALL       _TM1637_Init+0
;main.c,91 :: 		ADC_SET_UP();
	CALL       _ADC_SET_UP+0
;main.c,92 :: 		TM1637_DisplayDecimal(0,0);
	CLR        R4
	CLR        R5
	CLR        R2
	CLR        R3
	CALL       _TM1637_DisplayDecimal+0
;main.c,93 :: 		Write_DAC(0);
	CLR        R2
	CLR        R3
	CALL       _Write_DAC+0
;main.c,94 :: 		Delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L_set_up21:
	DEC        R16
	BRNE       L_set_up21
	DEC        R17
	BRNE       L_set_up21
	DEC        R18
	BRNE       L_set_up21
	NOP
;main.c,95 :: 		}
L_end_set_up:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _set_up

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;main.c,96 :: 		void main() {
;main.c,97 :: 		set_up();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	CALL       _set_up+0
;main.c,98 :: 		while (1)
L_main23:
;main.c,101 :: 		if (Button(&PIND,4,10,0)) e2=0;     //If the bttton is pushing.
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 4
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main84
	JMP        L_main25
L__main84:
	LDI        R27, 0
	STS        _e2+0, R27
L_main25:
;main.c,102 :: 		if (e2==0 && Button(&PIND,4,10,1)){ // If the bttton was pushing and after that is free.
	LDS        R16, _e2+0
	CPI        R16, 0
	BREQ       L__main85
	JMP        L__main64
L__main85:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 4
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main86
	JMP        L__main63
L__main86:
L__main62:
;main.c,103 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_main29:
	DEC        R16
	BRNE       L_main29
	DEC        R17
	BRNE       L_main29
	NOP
;main.c,104 :: 		var++;
	LDS        R16, _var+0
	MOV        R17, R16
	SUBI       R17, 255
	STS        _var+0, R17
;main.c,105 :: 		if(var > 1) var =0;
	LDI        R16, 1
	CP         R16, R17
	BRLO       L__main87
	JMP        L_main31
L__main87:
	LDI        R27, 0
	STS        _var+0, R27
L_main31:
;main.c,106 :: 		e2=1;
	LDI        R27, 1
	STS        _e2+0, R27
;main.c,102 :: 		if (e2==0 && Button(&PIND,4,10,1)){ // If the bttton was pushing and after that is free.
L__main64:
L__main63:
;main.c,109 :: 		if (Button(&PIND,5,10,0)) e0=0;     //If the bttton is pushing.
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 5
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main88
	JMP        L_main32
L__main88:
	LDI        R27, 0
	STS        _e0+0, R27
L_main32:
;main.c,110 :: 		if (e0==0 && Button(&PIND,5,10,1)){ // If the bttton was pushing and after that is free.
	LDS        R16, _e0+0
	CPI        R16, 0
	BREQ       L__main89
	JMP        L__main66
L__main89:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 5
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main90
	JMP        L__main65
L__main90:
L__main61:
;main.c,111 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_main36:
	DEC        R16
	BRNE       L_main36
	DEC        R17
	BRNE       L_main36
	NOP
;main.c,112 :: 		if(var == 0)volt++;
	LDS        R16, _var+0
	CPI        R16, 0
	BREQ       L__main91
	JMP        L_main38
L__main91:
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	SUBI       R16, 255
	SBCI       R17, 255
	STS        _volt+0, R16
	STS        _volt+1, R17
	JMP        L_main39
L_main38:
;main.c,113 :: 		else  volt=10*volt;
	LDI        R16, 10
	LDI        R17, 0
	LDS        R20, _volt+0
	LDS        R21, _volt+1
	CALL       _HWMul_16x16+0
	STS        _volt+0, R16
	STS        _volt+1, R17
L_main39:
;main.c,114 :: 		if(volt>2000) volt=0;
	LDS        R18, _volt+0
	LDS        R19, _volt+1
	LDI        R16, 208
	LDI        R17, 7
	CP         R16, R18
	CPC        R17, R19
	BRLO       L__main92
	JMP        L_main40
L__main92:
	LDI        R27, 0
	STS        _volt+0, R27
	STS        _volt+1, R27
L_main40:
;main.c,115 :: 		TM1637_DisplayDecimal(volt,0);
	CLR        R4
	CLR        R5
	LDS        R2, _volt+0
	LDS        R3, _volt+1
	CALL       _TM1637_DisplayDecimal+0
;main.c,116 :: 		e0=1;
	LDI        R27, 1
	STS        _e0+0, R27
;main.c,110 :: 		if (e0==0 && Button(&PIND,5,10,1)){ // If the bttton was pushing and after that is free.
L__main66:
L__main65:
;main.c,119 :: 		if (Button(&PIND,6,10,0)) e1=0;     //If the bttton is pushing.
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 6
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main93
	JMP        L_main41
L__main93:
	LDI        R27, 0
	STS        _e1+0, R27
L_main41:
;main.c,120 :: 		if (e1==0 && Button(&PIND,6,10,1)){ // If the bttton was pushing and after that is free.
	LDS        R16, _e1+0
	CPI        R16, 0
	BREQ       L__main94
	JMP        L__main68
L__main94:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 6
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main95
	JMP        L__main67
L__main95:
L__main60:
;main.c,121 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_main45:
	DEC        R16
	BRNE       L_main45
	DEC        R17
	BRNE       L_main45
	NOP
;main.c,122 :: 		if(volt==0) volt=2001;
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	CPI        R17, 0
	BRNE       L__main96
	CPI        R16, 0
L__main96:
	BREQ       L__main97
	JMP        L_main47
L__main97:
	LDI        R27, 209
	STS        _volt+0, R27
	LDI        R27, 7
	STS        _volt+1, R27
L_main47:
;main.c,123 :: 		if(var == 0) volt--;
	LDS        R16, _var+0
	CPI        R16, 0
	BREQ       L__main98
	JMP        L_main48
L__main98:
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	SUBI       R16, 1
	SBCI       R17, 0
	STS        _volt+0, R16
	STS        _volt+1, R17
	JMP        L_main49
L_main48:
;main.c,124 :: 		else volt = volt /10;
	LDI        R20, 10
	LDI        R21, 0
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	CALL       _Div_16x16_U+0
	MOVW       R16, R24
	STS        _volt+0, R16
	STS        _volt+1, R17
L_main49:
;main.c,125 :: 		TM1637_DisplayDecimal(volt,0);
	CLR        R4
	CLR        R5
	LDS        R2, _volt+0
	LDS        R3, _volt+1
	CALL       _TM1637_DisplayDecimal+0
;main.c,126 :: 		e1=1;
	LDI        R27, 1
	STS        _e1+0, R27
;main.c,120 :: 		if (e1==0 && Button(&PIND,6,10,1)){ // If the bttton was pushing and after that is free.
L__main68:
L__main67:
;main.c,128 :: 		if (Button(&PIND,7,10,0)) e3=0;     //If the bttton is pushing.
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 7
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main99
	JMP        L_main50
L__main99:
	LDI        R27, 0
	STS        _e3+0, R27
L_main50:
;main.c,129 :: 		if (e3==0 && Button(&PIND,7,10,1)){ // If the bttton was pushing and after that is free.
	LDS        R16, _e3+0
	CPI        R16, 0
	BREQ       L__main100
	JMP        L__main70
L__main100:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 7
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main101
	JMP        L__main69
L__main101:
L__main59:
;main.c,130 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_main54:
	DEC        R16
	BRNE       L_main54
	DEC        R17
	BRNE       L_main54
	NOP
;main.c,131 :: 		Write_volt(volt);
	LDS        R2, _volt+0
	LDS        R3, _volt+1
	CALL       _Write_volt+0
;main.c,132 :: 		e3=1;
	LDI        R27, 1
	STS        _e3+0, R27
;main.c,129 :: 		if (e3==0 && Button(&PIND,7,10,1)){ // If the bttton was pushing and after that is free.
L__main70:
L__main69:
;main.c,134 :: 		if (Button(&PIND,0,10,0)) Voltmeter();     //If the bttton is pushing.
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	CLR        R4
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main102
	JMP        L_main56
L__main102:
	CALL       _Voltmeter+0
L_main56:
;main.c,135 :: 		if(var==1) PORTD1_bit=1;
	LDS        R16, _var+0
	CPI        R16, 1
	BREQ       L__main103
	JMP        L_main57
L__main103:
	IN         R27, PORTD1_bit+0
	SBR        R27, BitMask(PORTD1_bit+0)
	OUT        PORTD1_bit+0, R27
	JMP        L_main58
L_main57:
;main.c,136 :: 		else PORTD1_bit=0;
	IN         R27, PORTD1_bit+0
	CBR        R27, BitMask(PORTD1_bit+0)
	OUT        PORTD1_bit+0, R27
L_main58:
;main.c,137 :: 		}
	JMP        L_main23
;main.c,138 :: 		}
L_end_main:
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
