#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/power_supply/main.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 1 "c:/users/usuario/documents/mikroc_pro_avr/power_supply/tm1637_lib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 8 "c:/users/usuario/documents/mikroc_pro_avr/power_supply/tm1637_lib.h"
void TM1637_Init(void);
void TM1637_Demo(void);
void TM1637_DisplayDecimal(int v, int displaySeparator);
void TM1637_SetBrightness(char brightness);
void TM1637_Start(void);
void TM1637_Stop(void);
void TM1637_ReadResult(void);
void TM1637_WriteByte(unsigned char b);
#line 1 "c:/users/usuario/documents/mikroc_pro_avr/power_supply/adc_atmega328p.h"



unsigned int ADC_measuring(short int canal);
void ADC_SET_UP(void);
#line 10 "C:/Users/Usuario/Documents/MikroC_pro_avr/power_supply/main.c"
sbit Soft_I2C_Scl_Output at PORTD3_bit;
sbit Soft_I2C_Sda_Output at PORTD2_bit;
sbit Soft_I2C_Scl_Input at PIND3_bit;
sbit Soft_I2C_Sda_Input at PIND2_bit;
sbit Soft_I2C_Scl_Direction at DDD3_bit;
sbit Soft_I2C_Sda_Direction at DDD2_bit;

unsigned int volt=0;
long i=0;
char e0=1, e1=1, e2=1, e3=1, var=0;

void Write_DAC( unsigned int vout)
{
 unsigned int dato[4];
 short int i=0;
 dato[0] =  0xC0 ;
 dato[1] =  0x40 ;
 dato[2] = (vout / 16);
 dato[3] = (vout % 16) << 4;
 soft_i2c_Start();
 for(i=0; i<=3; i++) {
 soft_i2c_Write(dato[i]);
 }
 Soft_I2C_Stop();
 }

void Write_volt( unsigned int vout)
{
 float VSAL;

 PORTB2_bit=1;

 VSAL= (vout/0.4884);
 VSAL=(unsigned int)VSAL;

 for(i=i; i<=VSAL; i++){
 Write_DAC(i);
 Delay_ms(10);
 }
 for(i=i; i>=VSAL; i--){
 Write_DAC(i);
 Delay_ms(10);
 }
 PORTB2_bit=0;
 }
void Voltmeter(){

 long vdd;
 unsigned int adc_rd=0;
 short int j=0;
 char aux=0;

 for(j=0; j<=2; j++){
 aux=0;
 adc_rd= ADC_measuring(2);
 vdd = (long)adc_rd * 2000;
 vdd = vdd / 1023;
 TM1637_DisplayDecimal(vdd,0);
 delay_ms(100);
 if (Button(&PIND,0,10,1)) TM1637_DisplayDecimal(volt,0), aux==1;
 }
 if(aux==1)j=2;
 else j=1;
}
void set_up() {
DDC2_bit=0;
DDD0_bit=0;
DDD4_bit=0;
DDD5_bit=0;
DDD6_bit=0;
DDD7_bit=0;
DDD1_bit=1;
DDB0_bit=1;
DDB1_bit=1;
DDB2_bit=1;
PORTD1_bit=0;
PORTB0_bit=0;
PORTB1_bit=0;
PORTB2_bit=0;
Soft_I2C_Init();
TM1637_Init();
ADC_SET_UP();
TM1637_DisplayDecimal(0,0);
Write_DAC(0);
Delay_ms(100);
}
void main() {
 set_up();
 while (1)
 {

 if (Button(&PIND,4,10,0)) e2=0;
 if (e2==0 && Button(&PIND,4,10,1)){
 Delay_ms(10);
 var++;
 if(var > 1) var =0;
 e2=1;
 }

 if (Button(&PIND,5,10,0)) e0=0;
 if (e0==0 && Button(&PIND,5,10,1)){
 Delay_ms(10);
 if(var == 0)volt++;
 else volt=10*volt;
 if(volt>2000) volt=0;
 TM1637_DisplayDecimal(volt,0);
 e0=1;
 }

 if (Button(&PIND,6,10,0)) e1=0;
 if (e1==0 && Button(&PIND,6,10,1)){
 Delay_ms(10);
 if(volt==0) volt=2001;
 if(var == 0) volt--;
 else volt = volt /10;
 TM1637_DisplayDecimal(volt,0);
 e1=1;
 }
 if (Button(&PIND,7,10,0)) e3=0;
 if (e3==0 && Button(&PIND,7,10,1)){
 Delay_ms(10);
 Write_volt(volt);
 e3=1;
 }
 if (Button(&PIND,0,10,0)) Voltmeter();
 if(var==1) PORTD1_bit=1;
 else PORTD1_bit=0;
 }
}
