
_TM1637_Init:

;tm1637_lib.c,12 :: 		void TM1637_Init(void)
;tm1637_lib.c,14 :: 		TM1637_SetBrightness(7);
	PUSH       R2
	LDI        R27, 7
	MOV        R2, R27
	CALL       _TM1637_SetBrightness+0
;tm1637_lib.c,15 :: 		TM1637_SetBrightness(8);
	LDI        R27, 8
	MOV        R2, R27
	CALL       _TM1637_SetBrightness+0
;tm1637_lib.c,16 :: 		}
L_end_TM1637_Init:
	POP        R2
	RET
; end of _TM1637_Init

_TM1637_DisplayDecimal:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 6
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;tm1637_lib.c,19 :: 		void TM1637_DisplayDecimal(int v, int displaySeparator)
;tm1637_lib.c,22 :: 		short int i =0;
;tm1637_lib.c,23 :: 		for ( i = 0; i < 4; ++i) {
; i start address is: 20 (R20)
	LDI        R20, 0
; i end address is: 20 (R20)
L_TM1637_DisplayDecimal0:
; i start address is: 20 (R20)
	CPI        R20, 4
	BRLT       L__TM1637_DisplayDecimal35
	JMP        L_TM1637_DisplayDecimal1
L__TM1637_DisplayDecimal35:
;tm1637_lib.c,24 :: 		digitArr[i] = segmentMap[v % 10];
	MOVW       R16, R28
	ADD        R16, R20
	LDI        R27, 0
	SBRC       R20, 7
	LDI        R27, 255
	ADC        R17, R27
	STD        Y+4, R16
	STD        Y+5, R17
	PUSH       R20
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R20, 10
	LDI        R21, 0
	MOVW       R16, R2
	CALL       _Div_16x16_S+0
	MOVW       R16, R24
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R20
	LDI        R18, #lo_addr(_segmentMap+0)
	LDI        R19, hi_addr(_segmentMap+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LPM        R18, Z
	LDD        R16, Y+4
	LDD        R17, Y+5
	MOVW       R30, R16
	ST         Z, R18
;tm1637_lib.c,25 :: 		if (i == 2 && displaySeparator) {
	CPI        R20, 2
	BREQ       L__TM1637_DisplayDecimal36
	JMP        L__TM1637_DisplayDecimal32
L__TM1637_DisplayDecimal36:
	MOV        R27, R4
	OR         R27, R5
	BRNE       L__TM1637_DisplayDecimal37
	JMP        L__TM1637_DisplayDecimal31
L__TM1637_DisplayDecimal37:
L__TM1637_DisplayDecimal30:
;tm1637_lib.c,26 :: 		digitArr[i] |= 1 << 7;
	MOVW       R16, R28
	MOV        R18, R20
	LDI        R19, 0
	SBRC       R20, 7
	LDI        R19, 255
	ADD        R18, R16
	ADC        R19, R17
	MOVW       R30, R18
	LD         R16, Z
	ORI        R16, 128
	MOVW       R30, R18
	ST         Z, R16
;tm1637_lib.c,25 :: 		if (i == 2 && displaySeparator) {
L__TM1637_DisplayDecimal32:
L__TM1637_DisplayDecimal31:
;tm1637_lib.c,28 :: 		v /= 10;
	PUSH       R20
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R20, 10
	LDI        R21, 0
	MOVW       R16, R2
	CALL       _Div_16x16_S+0
	MOVW       R16, R22
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R20
	MOVW       R2, R16
;tm1637_lib.c,23 :: 		for ( i = 0; i < 4; ++i) {
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
;tm1637_lib.c,29 :: 		}
; i end address is: 20 (R20)
	JMP        L_TM1637_DisplayDecimal0
L_TM1637_DisplayDecimal1:
;tm1637_lib.c,31 :: 		TM1637_Start();
	CALL       _TM1637_Start+0
;tm1637_lib.c,32 :: 		TM1637_WriteByte(0x40);
	PUSH       R3
	PUSH       R2
	LDI        R27, 64
	MOV        R2, R27
	CALL       _TM1637_WriteByte+0
	POP        R2
	POP        R3
;tm1637_lib.c,33 :: 		TM1637_ReadResult();
	CALL       _TM1637_ReadResult+0
;tm1637_lib.c,34 :: 		TM1637_Stop();
	CALL       _TM1637_Stop+0
;tm1637_lib.c,36 :: 		TM1637_Start();
	CALL       _TM1637_Start+0
;tm1637_lib.c,37 :: 		TM1637_WriteByte(0xc0);
	PUSH       R3
	PUSH       R2
	LDI        R27, 192
	MOV        R2, R27
	CALL       _TM1637_WriteByte+0
	POP        R2
	POP        R3
;tm1637_lib.c,38 :: 		TM1637_ReadResult();
	CALL       _TM1637_ReadResult+0
;tm1637_lib.c,40 :: 		for (i = 0; i < 4; ++i) {
; i start address is: 20 (R20)
	LDI        R20, 0
; i end address is: 20 (R20)
L_TM1637_DisplayDecimal6:
; i start address is: 20 (R20)
	CPI        R20, 4
	BRLT       L__TM1637_DisplayDecimal38
	JMP        L_TM1637_DisplayDecimal7
L__TM1637_DisplayDecimal38:
;tm1637_lib.c,41 :: 		TM1637_WriteByte(digitArr[3 - i]);
	LDI        R18, 3
	LDI        R19, 0
	SUB        R18, R20
	LDI        R27, 0
	SBRC       R20, 7
	LDI        R27, 255
	SBC        R19, R27
	MOVW       R16, R28
	MOVW       R30, R18
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _TM1637_WriteByte+0
	POP        R2
	POP        R3
;tm1637_lib.c,42 :: 		TM1637_ReadResult();
	CALL       _TM1637_ReadResult+0
;tm1637_lib.c,40 :: 		for (i = 0; i < 4; ++i) {
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
;tm1637_lib.c,43 :: 		}
; i end address is: 20 (R20)
	JMP        L_TM1637_DisplayDecimal6
L_TM1637_DisplayDecimal7:
;tm1637_lib.c,45 :: 		TM1637_Stop();
	CALL       _TM1637_Stop+0
;tm1637_lib.c,46 :: 		}
L_end_TM1637_DisplayDecimal:
	ADIW       R28, 5
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _TM1637_DisplayDecimal

_TM1637_SetBrightness:

;tm1637_lib.c,50 :: 		void TM1637_SetBrightness(char brightness)
;tm1637_lib.c,57 :: 		TM1637_Start();
	PUSH       R2
	CALL       _TM1637_Start+0
;tm1637_lib.c,58 :: 		TM1637_WriteByte(0x87 + brightness);
	MOV        R16, R2
	SUBI       R16, 121
	MOV        R2, R16
	CALL       _TM1637_WriteByte+0
;tm1637_lib.c,59 :: 		TM1637_ReadResult();
	CALL       _TM1637_ReadResult+0
;tm1637_lib.c,60 :: 		TM1637_Stop();
	CALL       _TM1637_Stop+0
;tm1637_lib.c,61 :: 		}
L_end_TM1637_SetBrightness:
	POP        R2
	RET
; end of _TM1637_SetBrightness

_TM1637_Start:

;tm1637_lib.c,63 :: 		void TM1637_Start(void)
;tm1637_lib.c,65 :: 		PORTB1_bit=1; //CLK_HIGH
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,66 :: 		PORTB0_bit=1;//DATA HIGH
	IN         R27, PORTB0_bit+0
	SBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;tm1637_lib.c,67 :: 		delay_us(2);
	LDI        R16, 10
L_TM1637_Start9:
	DEC        R16
	BRNE       L_TM1637_Start9
	NOP
	NOP
;tm1637_lib.c,68 :: 		PORTB0_bit=0; //DATA_LOW
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;tm1637_lib.c,69 :: 		}
L_end_TM1637_Start:
	RET
; end of _TM1637_Start

_TM1637_Stop:

;tm1637_lib.c,71 :: 		void TM1637_Stop(void)
;tm1637_lib.c,73 :: 		PORTB1_bit=0; //CLK LOW
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,74 :: 		delay_us(2);
	LDI        R16, 10
L_TM1637_Stop11:
	DEC        R16
	BRNE       L_TM1637_Stop11
	NOP
	NOP
;tm1637_lib.c,75 :: 		PORTB0_bit=0; //DATA_LOW
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;tm1637_lib.c,76 :: 		delay_us(2);
	LDI        R16, 10
L_TM1637_Stop13:
	DEC        R16
	BRNE       L_TM1637_Stop13
	NOP
	NOP
;tm1637_lib.c,77 :: 		PORTB1_bit=1; //CLK HIGH
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,78 :: 		delay_us(2);
	LDI        R16, 10
L_TM1637_Stop15:
	DEC        R16
	BRNE       L_TM1637_Stop15
	NOP
	NOP
;tm1637_lib.c,79 :: 		PORTB0_bit=1; //DATA HIGH
	IN         R27, PORTB0_bit+0
	SBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;tm1637_lib.c,80 :: 		}
L_end_TM1637_Stop:
	RET
; end of _TM1637_Stop

_TM1637_ReadResult:

;tm1637_lib.c,82 :: 		void TM1637_ReadResult(void)
;tm1637_lib.c,84 :: 		PORTB1_bit=0; //CLK LOW
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,85 :: 		delay_us(5);
	LDI        R16, 26
L_TM1637_ReadResult17:
	DEC        R16
	BRNE       L_TM1637_ReadResult17
	NOP
	NOP
;tm1637_lib.c,86 :: 		PORTB1_bit=1; //CLK HIGH
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,87 :: 		delay_us(2);
	LDI        R16, 10
L_TM1637_ReadResult19:
	DEC        R16
	BRNE       L_TM1637_ReadResult19
	NOP
	NOP
;tm1637_lib.c,88 :: 		PORTB1_bit=0; //CLK LOW
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,89 :: 		}
L_end_TM1637_ReadResult:
	RET
; end of _TM1637_ReadResult

_TM1637_WriteByte:

;tm1637_lib.c,91 :: 		void TM1637_WriteByte(unsigned char b)
;tm1637_lib.c,93 :: 		short int i = 0;
;tm1637_lib.c,94 :: 		for (i = 0; i < 8; ++i) {
; i start address is: 17 (R17)
	LDI        R17, 0
; i end address is: 17 (R17)
L_TM1637_WriteByte21:
; i start address is: 17 (R17)
	CPI        R17, 8
	BRLT       L__TM1637_WriteByte44
	JMP        L_TM1637_WriteByte22
L__TM1637_WriteByte44:
;tm1637_lib.c,95 :: 		PORTB1_bit=0; //CLK LOW
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,96 :: 		if (b & 0x01) {
	BST        R2, 0
	BRTS       L__TM1637_WriteByte45
	JMP        L_TM1637_WriteByte24
L__TM1637_WriteByte45:
;tm1637_lib.c,97 :: 		PORTB0_bit=1; //DATA HIGH
	IN         R27, PORTB0_bit+0
	SBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;tm1637_lib.c,98 :: 		}
	JMP        L_TM1637_WriteByte25
L_TM1637_WriteByte24:
;tm1637_lib.c,100 :: 		PORTB0_bit=0; //DATA_LOW
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;tm1637_lib.c,101 :: 		}
L_TM1637_WriteByte25:
;tm1637_lib.c,102 :: 		delay_us(3);
	LDI        R16, 16
L_TM1637_WriteByte26:
	DEC        R16
	BRNE       L_TM1637_WriteByte26
;tm1637_lib.c,103 :: 		b >>= 1;
	MOV        R16, R2
	LSR        R16
	MOV        R2, R16
;tm1637_lib.c,104 :: 		PORTB1_bit=1; //CLK HIGH
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;tm1637_lib.c,105 :: 		delay_us(3);
	LDI        R16, 16
L_TM1637_WriteByte28:
	DEC        R16
	BRNE       L_TM1637_WriteByte28
;tm1637_lib.c,94 :: 		for (i = 0; i < 8; ++i) {
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;tm1637_lib.c,106 :: 		}
; i end address is: 17 (R17)
	JMP        L_TM1637_WriteByte21
L_TM1637_WriteByte22:
;tm1637_lib.c,107 :: 		}
L_end_TM1637_WriteByte:
	RET
; end of _TM1637_WriteByte

tm1637_lib____?ag:

L_end_tm1637_lib___?ag:
	RET
; end of tm1637_lib____?ag
