#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/power_supply/tm1637_lib.c"
#line 1 "c:/users/usuario/documents/mikroc_pro_avr/power_supply/tm1637_lib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 8 "c:/users/usuario/documents/mikroc_pro_avr/power_supply/tm1637_lib.h"
void TM1637_Init(void);
void TM1637_Demo(void);
void TM1637_DisplayDecimal(int v, int displaySeparator);
void TM1637_SetBrightness(char brightness);
void TM1637_Start(void);
void TM1637_Stop(void);
void TM1637_ReadResult(void);
void TM1637_WriteByte(unsigned char b);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 6 "C:/Users/Usuario/Documents/MikroC_pro_avr/power_supply/tm1637_lib.c"
const char segmentMap[] = {
 0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07,
 0x7f, 0x6f, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71,
 0x00
};

void TM1637_Init(void)
{
 TM1637_SetBrightness(7);
 TM1637_SetBrightness(8);
}


void TM1637_DisplayDecimal(int v, int displaySeparator)
{
 unsigned char digitArr[4];
 short int i =0;
 for ( i = 0; i < 4; ++i) {
 digitArr[i] = segmentMap[v % 10];
 if (i == 2 && displaySeparator) {
 digitArr[i] |= 1 << 7;
 }
 v /= 10;
 }

 TM1637_Start();
 TM1637_WriteByte(0x40);
 TM1637_ReadResult();
 TM1637_Stop();

 TM1637_Start();
 TM1637_WriteByte(0xc0);
 TM1637_ReadResult();

 for (i = 0; i < 4; ++i) {
 TM1637_WriteByte(digitArr[3 - i]);
 TM1637_ReadResult();
 }

 TM1637_Stop();
}



void TM1637_SetBrightness(char brightness)
{





 TM1637_Start();
 TM1637_WriteByte(0x87 + brightness);
 TM1637_ReadResult();
 TM1637_Stop();
}

void TM1637_Start(void)
{
 PORTB1_bit=1;
 PORTB0_bit=1;
 delay_us(2);
 PORTB0_bit=0;
}

void TM1637_Stop(void)
{
 PORTB1_bit=0;
 delay_us(2);
 PORTB0_bit=0;
 delay_us(2);
 PORTB1_bit=1;
 delay_us(2);
 PORTB0_bit=1;
}

void TM1637_ReadResult(void)
{
 PORTB1_bit=0;
 delay_us(5);
 PORTB1_bit=1;
 delay_us(2);
 PORTB1_bit=0;
}

void TM1637_WriteByte(unsigned char b)
{
 short int i = 0;
 for (i = 0; i < 8; ++i) {
 PORTB1_bit=0;
 if (b & 0x01) {
 PORTB0_bit=1;
 }
 else {
 PORTB0_bit=0;
 }
 delay_us(3);
 b >>= 1;
 PORTB1_bit=1;
 delay_us(3);
 }
}
